/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/css/common/cssTokenTypes",["require","exports"],function(t,e){e.TOKEN_SELECTOR="entity.name.selector",e.TOKEN_SELECTOR_TAG="entity.name.tag",e.TOKEN_PROPERTY="support.type.property-name",e.TOKEN_VALUE="support.property-value",e.TOKEN_AT_KEYWORD="keyword.control.at-rule"});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(t,e,n,r);switch(arguments.length){case 2:return t.reduceRight(function(t,e){return e&&e(t)||t},e);case 3:return t.reduceRight(function(t,r){return void(r&&r(e,n))},void 0);case 4:return t.reduceRight(function(t,r){return r&&r(e,n,t)||t},r)}},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/css/common/css",["require","exports","vs/editor/common/modes/supports","vs/base/common/objects","vs/editor/common/modes","vs/platform/thread/common/threadService","vs/languages/css/common/cssTokenTypes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/instantiation/common/descriptors","vs/editor/common/modes/supports/onEnter","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread"],function(t,e,n,r,o,i,s,c,a,u,p,l,f){e.cssTokenTypes=s,function(t){t[t.Selector=0]="Selector",t[t.Rule=1]="Rule",t[t.Value=2]="Value",t[t.ValuePostUrl=3]="ValuePostUrl",t[t.ValueInUrlFunction=4]="ValueInUrlFunction",t[t.Unit=5]="Unit",t[t.Meta=6]="Meta",t[t.MetaPostUrl=7]="MetaPostUrl",t[t.MetaInUrlFunction=8]="MetaInUrlFunction"}(e.States||(e.States={}));var h=e.States,k=/^-?-?([a-zA-Z]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))([\w\-]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))*/,d=function(t){function e(e,n,r,o,i,s){t.call(this,e),this.kind=n,this.inComment=r,this.quote=o,this.inMeta=i,this.metaBraceCount=s}return __extends(e,t),e.prototype.nextState=function(t,e){return this.kind=t,e},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.inComment,this.quote,this.inMeta,this.metaBraceCount)},e.prototype.equals=function(e){return t.prototype.equals.call(this,e)&&r.equals(this,e)},e.prototype.tokenizeInComment=function(t){return/\*\/$/.test(t.advanceUntilString("*/",!0))&&(this.inComment=!1),{type:"comment.css"}},e.prototype.tokenizeInString=function(t){for(var e,n=!1,r=this.quote;!t.eos();)if(e=t.next(),n)n=!1;else if("\\"===e)n=!0;else if(e===r){this.quote=null;break}return{type:"string.css"}},e.prototype.consumeIdent=function(t){return t.goBack(1),t.advanceIfRegExp2(k)?!0:(t.advance(1),!1)},e.prototype.tokenize=function(t){if(this.inComment)return this.tokenizeInComment(t);if(null!==this.quote)return this.tokenizeInString(t);if(t.skipWhitespace2())return{type:""};if(t.advanceIfString2("/*"))return this.inComment=!0,this.tokenizeInComment(t);if(t.advanceIfString2("'"))return this.quote="'",this.tokenizeInString(t);if(t.advanceIfString2('"'))return this.quote='"',this.tokenizeInString(t);var e=t.next();switch(this.kind){case h.ValuePostUrl:if("("===e)return this.nextState(h.ValueInUrlFunction,{type:"punctuation.parenthesis.css",bracket:o.Bracket.Open});this.kind=h.Value;break;case h.MetaPostUrl:if("("===e)return this.nextState(h.MetaInUrlFunction,{type:"punctuation.parenthesis.css",bracket:o.Bracket.Open});this.kind=h.Meta;break;case h.ValueInUrlFunction:case h.MetaInUrlFunction:if(")"!==e)return t.advanceIfRegExp2(/^[^\)]*/),{type:"string.css"};this.kind=this.kind===h.ValueInUrlFunction?h.Value:h.Meta}switch(this.kind){case h.Selector:return"{"===e?this.nextState(h.Rule,{type:"punctuation.bracket.css",bracket:o.Bracket.Open}):"("===e||")"===e?{type:"punctuation.parenthesis.css",bracket:"("===e?o.Bracket.Open:o.Bracket.Close}:"@"!==e||this.inMeta?"}"===e&&this.inMeta?(this.inMeta=!1,this.nextState(h.Selector,{type:"punctuation.bracket.css",bracket:o.Bracket.Close})):/[\*\(\)\[\]\+>=\~\|;]/.test(e)?{type:"punctuation.css"}:"#"===e?(t.advanceIfRegExp2(k),{type:s.TOKEN_SELECTOR+".id.css"}):"."===e?(t.advanceIfRegExp2(k),{type:s.TOKEN_SELECTOR+".class.css"}):(this.consumeIdent(t),{type:s.TOKEN_SELECTOR_TAG+".css"}):(t.advanceIfRegExp2(k),this.nextState(h.Meta,{type:s.TOKEN_AT_KEYWORD+".css"}));case h.Meta:if("{"===e){var n=h.Rule;return this.inMeta&&(n=h.Selector),this.nextState(n,{type:"punctuation.bracket.css",bracket:o.Bracket.Open})}return"("===e||")"===e?{type:"punctuation.parenthesis.css",bracket:"("===e?o.Bracket.Open:o.Bracket.Close}:";"===e?(0===this.metaBraceCount&&(this.inMeta=!1),this.nextState(h.Selector,{type:"punctuation.css"})):"u"!==e&&"U"!==e||!t.advanceIfStringCaseInsensitive2("rl")?/[\*\(\)\[\]\+>=\~\|]/.test(e)?{type:"punctuation.css"}:(this.inMeta=!0,this.consumeIdent(t),{type:s.TOKEN_VALUE+".css"}):(t.advanceIfStringCaseInsensitive2("-prefix"),this.nextState(h.MetaPostUrl,{type:s.TOKEN_VALUE+".css"}));case h.Rule:return"}"===e?this.nextState(h.Selector,{type:"punctuation.bracket.css",bracket:o.Bracket.Close}):":"===e?this.nextState(h.Value,{type:"punctuation.css"}):"("===e||")"===e?{type:"punctuation.parenthesis.css",bracket:"("===e?o.Bracket.Open:o.Bracket.Close}:(this.consumeIdent(t),{type:s.TOKEN_PROPERTY+".css"});case h.Value:if("}"===e)return this.nextState(h.Selector,{type:"punctuation.bracket.css",bracket:o.Bracket.Close});if(";"===e)return this.nextState(h.Rule,{type:"punctuation.css"});if(("u"===e||"U"===e)&&t.advanceIfStringCaseInsensitive2("rl"))return this.nextState(h.ValuePostUrl,{type:s.TOKEN_VALUE+".css"});if("("===e||")"===e)return{type:"punctuation.parenthesis.css",bracket:"("===e?o.Bracket.Open:o.Bracket.Close};if(","===e)return{type:"punctuation.css"};if("#"===e)return t.advanceIfRegExp2(/^[\w]*/),{type:s.TOKEN_VALUE+".hex.css"};if(/\d/.test(e)||/-|\+/.test(e)&&!t.eos()&&/\d/.test(t.peek()))return t.advanceIfRegExp2(/^[\d\.]*/),this.nextState(h.Unit,{type:s.TOKEN_VALUE+".numeric.css"});if("!"===e)return{type:s.TOKEN_VALUE+".keyword.css"};if(("i"===e||"I"===e)&&t.advanceIfStringCaseInsensitive2("mportant"))return{type:s.TOKEN_VALUE+".keyword.css"};if(this.consumeIdent(t))return{type:s.TOKEN_VALUE+".css"};break;case h.Unit:return t.goBack(1),t.advanceIfRegExp2(/^(em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)/)?{type:s.TOKEN_VALUE+".unit.css"}:(this.nextState(h.Value,null),this.tokenize(t))}return{type:""}},e}(a.AbstractState);e.State=d;var m=function(t){function e(e,r,o){var i=this;t.call(this,e,r,o),this.tokenizationSupport=new n.TokenizationSupport(this,{getInitialState:function(){return new d(i,h.Selector,!1,null,!1,0)}},!1,!1),this.electricCharacterSupport=new n.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"punctuation.bracket.css",open:"{",close:"}",isElectric:!0}]}),this.extraInfoSupport=this,this.referenceSupport=new n.ReferenceSupport(this,{tokens:[s.TOKEN_PROPERTY+".css",s.TOKEN_VALUE+".css",s.TOKEN_SELECTOR_TAG+".css"],findReferences:function(t,e,n){return i.findReferences(t,e)}}),this.logicalSelectionSupport=this,this.outlineSupport=this,this.declarationSupport=new n.DeclarationSupport(this,{tokens:[s.TOKEN_VALUE+".css"],findDeclaration:function(t,e){return i.findDeclaration(t,e)}}),this.characterPairSupport=new n.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string"]}]}),this.suggestSupport=new n.SuggestSupport(this,{triggerCharacters:[" ",":"],excludeTokens:["comment.css","string.css"],suggest:function(t,e){return i.suggest(t,e)}}),this.onEnterSupport=new p.OnEnterSupport(this.getId(),{brackets:[{open:"(",close:")"},{open:"{",close:"}"},{open:"[",close:"]"}]}),this.quickFixSupport=this}return __extends(e,t),e.prototype._getWorkerDescriptor=function(){return u.createAsyncDescriptor2("vs/languages/css/common/cssWorker","CSSWorker")},e.prototype.findDeclaration=function(t,e){return this._worker(function(n){return n.findDeclaration(t,e)})},e.prototype.computeInfo=function(t,e){return this._worker(function(n){return n.computeInfo(t,e)})},e.prototype.findReferences=function(t,e){return this._worker(function(n){return n.findReferences(t,e)})},e.prototype.getRangesToPosition=function(t,e){return this._worker(function(n){return n.getRangesToPosition(t,e)})},e.prototype.getOutline=function(t){return this._worker(function(e){return e.getOutline(t)})},e.prototype.getCommentsConfiguration=function(){return{blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},e.prototype.getWordDefinition=function(){return/(#?-?\d*\.\d\w*%?)|((::|[@#.!:])?[\w-?]+%?)|::|[@#.!:]/g},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.prototype.getQuickFixes=function(t,e){return this._worker(function(n){return n.getQuickFixes(t,e)})},e.prototype.runQuickFixAction=function(t,e,n){return this._worker(function(r){return r.runQuickFixAction(t,e,n)})},e.$findDeclaration=i.OneWorkerAttr(e,e.prototype.findDeclaration),e.$computeInfo=i.OneWorkerAttr(e,e.prototype.computeInfo),e.$findReferences=i.OneWorkerAttr(e,e.prototype.findReferences),e.$getRangesToPosition=i.OneWorkerAttr(e,e.prototype.getRangesToPosition),e.$getOutline=i.OneWorkerAttr(e,e.prototype.getOutline),e.$findColorDeclarations=i.OneWorkerAttr(e,e.prototype.findColorDeclarations),e.getQuickFixes=i.OneWorkerAttr(e,e.prototype.getQuickFixes),e.runQuickFixAction=i.OneWorkerAttr(e,e.prototype.runQuickFixAction),e=__decorate([__param(1,l.IInstantiationService),__param(2,f.IThreadService)],e)}(c.AbstractMode);e.CSSMode=m});