/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/less/common/lessTokenTypes",["require","exports"],function(e,t){t.TOKEN_SELECTOR="entity.name.selector",t.TOKEN_SELECTOR_TAG="entity.name.tag",t.TOKEN_PROPERTY="support.type.property-name",t.TOKEN_VALUE="support.property-value",t.TOKEN_AT_KEYWORD="keyword.control.at-rule"});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/languages/less/common/less",["require","exports","vs/base/common/winjs.base","vs/editor/common/modes/monarch/monarch","vs/editor/common/modes/monarch/monarchCompile","vs/languages/less/common/lessTokenTypes","vs/editor/common/modes/supports","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors","vs/editor/common/services/modeService","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/services/modelService"],function(e,t,n,r,o,i,s,a,c,u,p,l,d){t.language={displayName:"LESS",name:"less",wordDefinition:/(#?-?\d*\.\d\w*%?)|([@#!.:]?[\w-?]+%?)|[@#!.]/g,defaultToken:"",lineComment:"//",blockCommentStart:"/*",blockCommentEnd:"*/",identifier:"-?-?([a-zA-Z]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))([\\w\\-]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))*",identifierPlus:"-?-?([a-zA-Z:.]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))([\\w\\-:.]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))*",brackets:[{open:"{",close:"}",token:"punctuation.curly"},{open:"[",close:"]",token:"punctuation.bracket"},{open:"(",close:")",token:"punctuation.parenthesis"},{open:"<",close:">",token:"punctuation.angle"}],tokenizer:{root:[{include:"@nestedJSBegin"},["[ \\t\\r\\n]+",""],{include:"@comments"},{include:"@keyword"},{include:"@strings"},{include:"@numbers"},["[*_]?[a-zA-Z\\-\\s]+(?=:.*(;|(\\\\$)))",i.TOKEN_PROPERTY,"@attribute"],["url(\\-prefix)?\\(",{token:"function",bracket:"@open",next:"@urldeclaration"}],["[{}()\\[\\]]","@brackets"],["[,:;]","punctuation"],["#@identifierPlus",i.TOKEN_SELECTOR+".id"],["&",i.TOKEN_SELECTOR_TAG],["\\.@identifierPlus(?=\\()",i.TOKEN_SELECTOR+".class","@attribute"],["\\.@identifierPlus",i.TOKEN_SELECTOR+".class"],["@identifierPlus",i.TOKEN_SELECTOR_TAG],{include:"@operators"},["@(@identifier(?=[:,\\)]))","variable","@attribute"],["@(@identifier)","variable"],["@","key","@atRules"]],nestedJSBegin:[["``","punctuation.backtick"],["`",{token:"punctuation.backtick",bracket:"@open",next:"@nestedJSEnd",nextEmbedded:"text/javascript"}]],nestedJSEnd:[["`",{token:"punctuation.backtick",bracket:"@close",next:"@pop"}],[".",{token:"@rematch",next:"@javascript_block"}]],javascript_block:[["`",{token:"@rematch",next:"@pop",nextEmbedded:"@pop"}]],operators:[["[<>=\\+\\-\\*\\/\\^\\|\\~]","operator"]],keyword:[["(@[\\s]*import|![\\s]*important|true|false|when|iscolor|isnumber|isstring|iskeyword|isurl|ispixel|ispercentage|isem|hue|saturation|lightness|alpha|lighten|darken|saturate|desaturate|fadein|fadeout|fade|spin|mix|round|ceil|floor|percentage)\\b","keyword"]],urldeclaration:[{include:"@strings"},["[^)\r\n]+","string"],["\\)",{token:"tag",bracket:"@close",next:"@pop"}]],attribute:[{include:"@nestedJSBegin"},{include:"@comments"},{include:"@strings"},{include:"@numbers"},{include:"@keyword"},["[a-zA-Z\\-]+(?=\\()",i.TOKEN_VALUE,"@attribute"],[">","operator","@pop"],["@identifier",i.TOKEN_VALUE],{include:"@operators"},["@(@identifier)","variable"],["[)\\}]","@brackets","@pop"],["[{}()\\[\\]>]","@brackets"],["[;]","punctuation","@pop"],["[,=:]","punctuation"],["\\s",""],[".",i.TOKEN_VALUE]],comments:[["\\/\\*","comment","@comment"],["\\/\\/+.*","comment"]],comment:[["\\*\\/","comment","@pop"],[".","comment"]],numbers:[["(\\d*\\.)?\\d+([eE][\\-+]?\\d+)?",{token:i.TOKEN_VALUE+".numeric",next:"@units"}],["#[0-9a-fA-F_]+(?!\\w)",i.TOKEN_VALUE+".rgb-value"]],units:[["((em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)\\b)?",i.TOKEN_VALUE+".unit","@pop"]],strings:[['~?"',{token:"string.punctuation",bracket:"@open",next:"@stringsEndDoubleQuote"}],["~?'",{token:"string.punctuation",bracket:"@open",next:"@stringsEndQuote"}]],stringsEndDoubleQuote:[['\\\\"',"string"],['"',{token:"string.punctuation",next:"@popall",bracket:"@close"}],[".","string"]],stringsEndQuote:[["\\\\'","string"],["'",{token:"string.punctuation",next:"@popall",bracket:"@close"}],[".","string"]],atRules:[{include:"@comments"},{include:"@strings"},["[()]","punctuation"],["[\\{;]","punctuation","@pop"],[".","key"]]}};var m=function(e){function r(n,r,a,c,u){var p=this;e.call(this,n,o.compile(t.language),r,a,c,u),this.modeService=c,this.extraInfoSupport=this,this.referenceSupport=new s.ReferenceSupport(this,{tokens:[i.TOKEN_PROPERTY+".less",i.TOKEN_VALUE+".less","variable.less",i.TOKEN_SELECTOR+".class.less",i.TOKEN_SELECTOR+".id.less","selector.less"],findReferences:function(e,t,n){return p.findReferences(e,t)}}),this.logicalSelectionSupport=this,this.declarationSupport=new s.DeclarationSupport(this,{tokens:["variable.less",i.TOKEN_SELECTOR+".class.less",i.TOKEN_SELECTOR+".id.less","selector.less"],findDeclaration:function(e,t){return p.findDeclaration(e,t)}}),this.outlineSupport=this,this.suggestSupport=new s.SuggestSupport(this,{triggerCharacters:[],excludeTokens:["comment.less","string.less"],suggest:function(e,t){return p.suggest(e,t)}})}return __extends(r,e),r.prototype._getWorkerDescriptor=function(){return c.createAsyncDescriptor2("vs/languages/less/common/lessWorker","LessWorker")},r.prototype._worker=function(t){var r=this;return this.modeService.getOrCreateMode("css").then(function(e){return e._worker(function(e){return n.TPromise.as(!0)})}).then(function(){return e.prototype._worker.call(r,t)})},r.prototype.findReferences=function(e,t){return this._worker(function(n){return n.findReferences(e,t)})},r.prototype.getRangesToPosition=function(e,t){return this._worker(function(n){return n.getRangesToPosition(e,t)})},r.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},r.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},r.prototype.findDeclaration=function(e,t){return this._worker(function(n){return n.findDeclaration(e,t)})},r.prototype.findColorDeclarations=function(e){return this._worker(function(t){return t.findColorDeclarations(e)})},r.$findReferences=a.OneWorkerAttr(r,r.prototype.findReferences),r.$getRangesToPosition=a.OneWorkerAttr(r,r.prototype.getRangesToPosition),r.$computeInfo=a.OneWorkerAttr(r,r.prototype.computeInfo),r.$getOutline=a.OneWorkerAttr(r,r.prototype.getOutline),r.$findDeclaration=a.OneWorkerAttr(r,r.prototype.findDeclaration),r.$findColorDeclarations=a.OneWorkerAttr(r,r.prototype.findColorDeclarations),r=__decorate([__param(1,p.IInstantiationService),__param(2,l.IThreadService),__param(3,u.IModeService),__param(4,d.IModelService)],r)}(r.MonarchMode);t.LESSMode=m});